=== debian/changelog ===
openqa (5.1764349525.ffb594867-1) unstable; urgency=medium

  * Update to new upstream version 5.1764349525.ffb594867.
  * Avoid upstream MCP dependency (while it is not in Debian)

 -- Philip Hands <phil@hands.com>  Tue, 02 Dec 2025 16:33:31 +0100

openqa (5.1754383059.0426baa1d-3) unstable; urgency=medium

  [ Philip Hands ]
  * update to Standards-Version: 4.7.2
  * Recommend qemu-system-native (to avoid dragging in all archs)
  * switch to dpkg-query --list for worker package list

  [ Roland Clobus ]
  * Move openqa-cli.yaml to openqa-client (Closes: #1118588)

 -- Philip Hands <phil@hands.com>  Wed, 19 Nov 2025 13:20:33 +0100
